#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

volatile int a, b, sum, done;

pthread_t        server_thread;
pthread_cond_t   server_cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t  server_mutex = PTHREAD_MUTEX_INITIALIZER;

pthread_t        client_thread;
pthread_cond_t   client_cond = PTHREAD_COND_INITIALIZER;
pthread_mutex_t  client_mutex = PTHREAD_MUTEX_INITIALIZER;

void *server (void *)
{
  do
    {
      /* wait for client request */
      pthread_cond_wait (&server_cond, &server_mutex);

      /* process client request */
      int s = a + b;

      /* done with the request */
      pthread_mutex_unlock (&server_mutex);

      /* send reply */
      pthread_mutex_lock (&client_mutex);
      sum = s;
      pthread_mutex_unlock (&client_mutex);

      /* ensure we will get waiting for the next request */
      pthread_mutex_lock (&server_mutex);

      /* make client run */
      pthread_cond_signal (&client_cond);

    } while (!done);
}

void *client (void *)
{
  int i, r = 0;

  for (i = 0; i < 1000000; i++)
    {
      /* ensure server is waiting */
      pthread_mutex_lock (&server_mutex);

      /* send message */
      a = 40;
      b = i;

      /* allow the server to run */
      pthread_mutex_unlock (&server_mutex);

      /* ensure we will get waiting on the condition */
      pthread_mutex_lock (&client_mutex);

      /* make server run */
      pthread_cond_signal (&server_cond);

      /* wait for server to process request */
      pthread_cond_wait (&client_cond, &client_mutex);
      //printf("%d + %d = %d\n", a, b, sum);
      r += sum;
      /* done processing the request */
      pthread_mutex_unlock (&client_mutex);
    }

  pthread_mutex_lock (&server_mutex);
  done = 1;
  pthread_mutex_unlock (&server_mutex);

  pthread_cond_signal (&server_cond);

  printf("%d (expected 1823293664)\n", r);
}

int main ()
{
  pthread_mutex_lock (&server_mutex);
  pthread_create (&server_thread, 0, server, 0);
  pthread_create (&client_thread, 0, client, 0);
  pthread_join (server_thread, 0);
  pthread_join (client_thread, 0);
  pthread_mutex_unlock (&server_mutex);
  return 0;
}
