#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include <assert.h>
#include <sys/select.h>

volatile int a, b, sum, done;

pthread_t	  server_thread;
int		  server_wakeup_fds[2];

pthread_t	  client_thread;
int		  client_wakeup_fds[2];

void wait (int *fds)
{
  fd_set rfds;
  FD_ZERO(&rfds);
  FD_SET(fds[0], &rfds);
  int done = 0;
  while (done != 1)
    {
      char buffer[2] = { 0, 0 };

      select (fds[0] + 1, &rfds, 0, 0, 0);
      done = read (fds[0], buffer, 1);
    }
}

void wakeup (int *fds)
{
  char buffer[2] = { 1, 0 };
  int done = 0;
  while (done != 1)
    done = write (fds[1], buffer, 1);
}

void *server (void *)
{
  do
    {
      /* wait for client request */
      wait (server_wakeup_fds);
      sum = a + b;
      wakeup (client_wakeup_fds);
    } while (!done);
}

void *client (void *)
{
  int i, r = 0;

  for (i = 0; i < 1000000; i++)
    {
      a = 40;
      b = i;

      wakeup (server_wakeup_fds);
      wait (client_wakeup_fds);
      r += sum;
    }
  done = 1;
  wakeup (server_wakeup_fds);

  printf("%d (expected 1823293664)\n", r);
}

int main ()
{
  int res1 = pipe (server_wakeup_fds);
  assert (res1 == 0);

  int res2 = pipe (client_wakeup_fds);
  assert (res2 == 0);

  pthread_create (&server_thread, 0, server, 0);
  pthread_create (&client_thread, 0, client, 0);
  pthread_join (server_thread, 0);
  pthread_join (client_thread, 0);
  return 0;
}
